import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;

public class Server {
  
  public static void main(String args[]) throws Exception {
    BarChartController.testing = false;
    BarChartController.init();
    
    Runtime.getRuntime().addShutdownHook(new Thread() {
      public void run() {
        try {
          BarChartController.shutdown();
        } catch (Exception e) {
          e.printStackTrace();
        }
      }
    });
    
    ServerSocket serverSocket = null;
    try {
      serverSocket = new ServerSocket(4444);
    } catch (IOException e) {
      System.out.println("Could not listen on port: 4444");
      System.exit(-1);
    }
    
    while (true) {
      Socket clientSocket = null;
      try {
          System.out.println("waiting for socket...");
          clientSocket = serverSocket.accept();
      } catch (IOException e) {
          System.out.println("Accept failed: 4444");
          System.exit(-1);
      }
      HandleClient client = new HandleClient();
      client.clientSocket = clientSocket;
      Thread t = new Thread(client);
      t.start();
    }
  }
  
  
      
 static class HandleClient implements Runnable {
  Socket clientSocket;
  public void run() {
    try {
      System.out.println("client connected");
      ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(clientSocket.getInputStream()));
      int vals[] = (int[])ois.readObject();
//      for (int i = 0; i < 5; i++) {
//        System.out.println(vals[i]);
//      }
      BarChartController.updateBars(vals);
      
      OutputStream os = clientSocket.getOutputStream();
      os.write(1);
      
      clientSocket.close();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
        
  }
}
